## ulex 0.1.0

=== DESCRIPTION ===
Package: ulex
Title: Unique Location Extractor
Version: 0.1.0
Authors@R: 
    person("Robert", "Marty", , "rmarty@worldbank.org", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-3164-3813"))
Description: Extracts coordinates of an event location from text based on dictionaries of landmarks, roads, and areas. Only returns the location of an event of interest and ignores other location references; for example, if determining the location of a road traffic crash from the text "crash near [location 1] heading towards [location 2]", only the coordinates of "location 1" would be returned. Moreover, accounts for differences in spelling between how a user references a location and how a location is captured in location dictionaries.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.1
Imports: dplyr, tidyr, readr, purrr, tidytext, stringr, stringi, ngram,
        hunspell, stringdist, tm, raster, parallel, sf, quanteda,
        geodist, spacyr, utils
URL: https://dime-worldbank.github.io/ulex/
NeedsCompilation: no
Packaged: 2024-06-16 16:43:41 UTC; robmarty
Author: Robert Marty [aut, cre] (<https://orcid.org/0000-0002-3164-3813>)
Maintainer: Robert Marty <rmarty@worldbank.org>
Repository: CRAN
Date/Publication: 2024-06-17 18:20:02 UTC

## ulex 0.1.1

=== DESCRIPTION ===
Package: ulex
Title: Unique Location Extractor
Version: 0.1.1
Authors@R: 
    person("Robert", "Marty", , "rmarty@worldbank.org", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-3164-3813"))
Description: Extracts coordinates of an event location from text based on dictionaries of landmarks, roads, and areas. Only returns the location of an event of interest and ignores other location references; for example, if determining the location of a road traffic crash from the text "crash near [location 1] heading towards [location 2]", only the coordinates of "location 1" would be returned. Moreover, accounts for differences in spelling between how a user references a location and how a location is captured in location dictionaries. For more information on the algorithm, see Milusheva et al. (2021) <doi:10.1371/journal.pone.0244317>.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
Depends: R (>= 4.1.0)
Imports: dplyr, tidyr, readr, purrr, tidytext, stringr, stringi, ngram,
        hunspell, stringdist, tm, raster, parallel, sf, quanteda,
        geodist, spacyr, utils
URL: https://dime-worldbank.github.io/ulex/
NeedsCompilation: no
Packaged: 2026-02-13 18:40:24 UTC; robmarty
Author: Robert Marty [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3164-3813>)
Maintainer: Robert Marty <rmarty@worldbank.org>
Repository: CRAN
Date/Publication: 2026-02-13 19:10:02 UTC

## ulex 0.4

=== Makefile ===
VERSION=0.4

all: ulexing.cma pa_ulex.cma
all.opt: ulexing.cma ulexing.cmxa pa_ulex.cma


install: all
	ocamlfind install ulex META $(wildcard *.cmi) $(wildcard *.a) $(wildcard *.cma) $(wildcard *.cmxa)

uninstall:
	ocamlfind remove ulex

ULEXING = utf8.mli utf8.ml ulexing.mli ulexing.ml
ULEX = cset.ml ulex.mli ulex.ml pa_ulex.ml

ulexing.cma: $(ULEXING)
	ocamlc -a -o ulexing.cma $(ULEXING)
ulexing.cmxa: $(ULEXING)
	ocamlopt -a -o ulexing.cmxa $(ULEXING)

pa_ulex.cma: $(ULEX)
	ocamlc -a -o pa_ulex.cma -pp 'camlp4o pa_extend.cmo q_MLast.cmo' -I +camlp4 $(ULEX)

clean:
	rm -f *.cm* *~ test *.o *.a *.html *.css

view_test: pa_ulex.cma
	camlp4o ./pa_ulex.cma pr_o.cmo -sep "\n" test.ml

run_test: ulexing.cma
	ocamlc -o test -pp 'camlp4o ./pa_ulex.cma' ulexing.cma test.ml
	./test
doc:
	ocamldoc -html ulexing.mli

PACKAGE = ulex-$(VERSION)
DISTRIB = CHANGES LICENSE META README Makefile *.ml *.mli
.PHONY: package
package: clean
	rm -Rf $(PACKAGE)
	mkdir $(PACKAGE)
	cp -R $(DISTRIB) $(PACKAGE)/
	tar czf $(PACKAGE).tar.gz $(PACKAGE)
	rm -Rf $(PACKAGE)

## ulex 0.5

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.4
+VERSION=0.5
 
 all: ulexing.cma pa_ulex.cma
 all.opt: ulexing.cma ulexing.cmxa pa_ulex.cma
@@ -22,14 +22,19 @@
 	ocamlc -a -o pa_ulex.cma -pp 'camlp4o pa_extend.cmo q_MLast.cmo' -I +camlp4 $(ULEX)
 
 clean:
-	rm -f *.cm* *~ test *.o *.a *.html *.css
+	rm -f *.cm* *~ test custom_ulexing *.o *.a *.html *.css
 
 view_test: pa_ulex.cma
 	camlp4o ./pa_ulex.cma pr_o.cmo -sep "\n" test.ml
 
-run_test: ulexing.cma
+run_test: ulexing.cma pa_ulex.cma
 	ocamlc -o test -pp 'camlp4o ./pa_ulex.cma' ulexing.cma test.ml
 	./test
+
+custom_ulexing: ulexing.cma pa_ulex.cma
+	ocamlc -o custom_ulexing -pp 'camlp4o ./pa_ulex.cma' ulexing.cma custom_ulexing.ml
+
+
 doc:
 	ocamldoc -html ulexing.mli

## ulex 0.7

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.5
+VERSION=0.7
 
 all: ulexing.cma pa_ulex.cma
 all.opt: ulexing.cma ulexing.cmxa pa_ulex.cma
@@ -21,8 +21,11 @@
 pa_ulex.cma: $(ULEX)
 	ocamlc -a -o pa_ulex.cma -pp 'camlp4o pa_extend.cmo q_MLast.cmo' -I +camlp4 $(ULEX)
 
+pa_ulex.ml: pa_ulex.ml.src
+	ocaml mk_pa_ulex.ml
+
 clean:
-	rm -f *.cm* *~ test custom_ulexing *.o *.a *.html *.css
+	rm -f *.cm* *~ test custom_ulexing *.o *.a *.html *.css pa_ulex.ml
 
 view_test: pa_ulex.cma
 	camlp4o ./pa_ulex.cma pr_o.cmo -sep "\n" test.ml
@@ -39,7 +42,7 @@
 	ocamldoc -html ulexing.mli
 
 PACKAGE = ulex-$(VERSION)
-DISTRIB = CHANGES LICENSE META README Makefile *.ml *.mli
+DISTRIB = CHANGES LICENSE META README Makefile *.ml *.mli *.ml.src
 .PHONY: package
 package: clean
 	rm -Rf $(PACKAGE)

## ulex 1.0

=== Makefile ===
VERSION=1.0
# Don't forget to change META file as well

ALL=pa_ulex.cma ulexing.cma
OCAMLBUILD=ocamlbuild -byte-plugin

all::
	$(OCAMLBUILD) $(ALL)
all.opt::
	$(OCAMLBUILD) $(ALL) $(ALL:.cma=.cmxa)

MODS=ulexing utf16 utf8

install: all
	cd _build && $(MAKE) -f ../Makefile realinstall

realinstall:
	ocamlfind install ulex ../META $(wildcard $(MODS:=.mli) $(MODS:=.cmi) $(MODS:=.cmx) pa_ulex.cma ulexing.a ulexing.cma ulexing.cmxa)

uninstall:
	ocamlfind remove ulex

clean:
	$(OCAMLBUILD) -clean
	rm -f *~ *.html *.css *.tar.gz

view_test: all
	camlp4o -printer ocaml ./_build/pa_ulex.cma test.ml

run_test:
	ocamlbuild test.byte
	./test.byte

custom_ulexing.byte:
	$(OCAMLBUILD) custom_ulexing.byte

doc:
	ocamldoc -html ulexing.mli

PACKAGE = ulex-$(VERSION)
DISTRIB = CHANGES LICENSE META README Makefile _tags *.ml *.mli
.PHONY: package
package: clean
	rm -Rf $(PACKAGE)
	mkdir $(PACKAGE)
	cp -R $(DISTRIB) $(PACKAGE)/
	tar czf $(PACKAGE).tar.gz $(PACKAGE)
	rm -Rf $(PACKAGE)

upload: 
	$(MAKE) package
	rsync -avz $(PACKAGE).tar.gz cduce@di.ens.fr:public_html/download
	$(MAKE) doc
	rsync -avz *.html *.css cduce@di.ens.fr:public_html/ulex

## ulex 1.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=1.0
+VERSION=1.1
 # Don't forget to change META file as well
 
 ALL=pa_ulex.cma ulexing.cma
@@ -49,6 +49,7 @@
 
 upload: 
 	$(MAKE) package
-	rsync -avz $(PACKAGE).tar.gz cduce@di.ens.fr:public_html/download
+	rsync -avz $(PACKAGE).tar.gz brome.pps.jussieu.fr:/home/web/wwwcduce/public_html/download
 	$(MAKE) doc
-	rsync -avz *.html *.css cduce@di.ens.fr:public_html/ulex
+#	rsync -avz *.html *.css cduce@di.ens.fr:public_html/ulex
+	rsync -avz CHANGES *.html *.css brome.pps.jussieu.fr:/home/web/wwwcduce/public_html/ulex

=== debian/changelog ===
ulex (1.1-4build1) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:35:44 +0000

ulex (1.1-4) unstable; urgency=medium

  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Thu, 12 Sep 2019 08:38:35 +0200

ulex (1.1-3) unstable; urgency=medium

  * Add ocamlbuild to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jul 2017 12:20:31 +0200

ulex (1.1-2) unstable; urgency=low

  * Use dh-ocaml 0.9 for dependency generation
  * Switch source package format to 3.0 (quilt)
  * debian/control:
    - add myself to Uploaders, remove Stefano (on his request)
    - move to section ocaml
    - bump Standards-Version to 3.8.4
  * Refresh debian/copyright

 -- Stéphane Glondu <glondu@debian.org>  Tue, 20 Apr 2010 15:12:14 +0200

ulex (1.1-1) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * New Upstream Version
  * bump debhelper compatibility level to 7
  * rebuild against ocaml 3.11, bump build-deps accordingly
  * debian/rules: use ocaml.mk as a CDBS "rules" snippet
  * debian/control: bump standards-version to 3.8.0 (no changes needed)
  * debian/*.in: use specific subst var instead of make assumption over
    stdlib dir layout

  [ Stephane Glondu ]
  * Switching packaging to git

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 28 Feb 2009 22:42:58 +0100

ulex (1.0-4) unstable; urgency=low

  * modify debian/watch to grep for version numbers in the HTML, to avoid 403
    errors (Closes: #450004)

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 31 Dec 2007 17:58:57 +0100

ulex (1.0-3) unstable; urgency=low

  * fix vcs-svn field to point just above the debian/ dir
  * update standards-version, no changes needed
  * moving myself to uploaders, setting d-o-m as the maintainer
  * add Homepage field to debian/control
  * debian/patches/: add missing descriptions for patch install_destdir

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 31 Dec 2007 17:15:34 +0100

ulex (1.0-2) unstable; urgency=low

  * debian/copyright
    - update some out-of-date information about upstream author
    - update license, it was wrongly described as LGPL while it is MIT
  * debian/control
    - bump ocaml-nox build-dep to >= 3.10.0-8 to ensure the fixed version of
      the CDBS class is used
  * debian/rules
    - enable generation of ocamldoc API reference (delegated to CDBS)

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 03 Sep 2007 15:16:20 +0200

ulex (1.0-1) experimental; urgency=low

  * new upstream release
  * rebuild with ocaml 3.10
    - add build-dep on camlp4 and camlp4-extra, now separate packages
    - add dep on camlp4
  * debian/watch
    - add watch file
  * debian/patches/
    - rename patches to avoid sequence numbers (00list is enough) and to use
      more meaningful names
    - refresh patch install_destdir to match new upstream Makefile
    - remove patch meta_version (no longer needed)
  * bump debhelper dep and compatibility level to 5

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 14 Jul 2007 11:53:17 +0200

ulex (0.8-6) unstable; urgency=low

  * debian/rules
    - use ocaml.mk
  * debian/control
    - bumped build dependency on ocaml-nox to >= 3.09.2-7, since we now use
      ocaml.mk
    - fixed a typo in the long description (closes: #390226)

 -- Stefano Zacchiroli <zack@debian.org>  Sat,  4 Nov 2006 09:30:45 +0100

ulex (0.8-5) unstable; urgency=low

  * debian/rules
    - removed no longer needed workaround for cdbs + dpatch
    - avoid to create debian/control from debian/control.in on ocamlinit
    - removed from the source package files which are generated at build time
      from the corresponding .in files
  * debian/control.in
    - file removed, no longer needed

 -- Stefano Zacchiroli <zack@debian.org>  Wed,  6 Sep 2006 10:08:02 +0200

ulex (0.8-4) unstable; urgency=low

  * Upload to unstable.

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 16 May 2006 20:12:41 +0000

ulex (0.8-3) experimental; urgency=low

  * Rebuilt against OCaml 3.09.2, bumped deps accordingly.
  * Bumped Standards-Version to 3.7.2 (no changes needed).

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 11 May 2006 22:12:52 +0000

ulex (0.8-2) unstable; urgency=low

  * Rebuilt against OCaml 3.09.1, bumped deps accordingly.

 -- Stefano Zacchiroli <zack@debian.org>  Sat,  7 Jan 2006 14:39:04 +0100

ulex (0.8-1) unstable; urgency=low

  * New upstream release
  * Rebuilt with ocaml 3.09
  * debian/*
    - no longer hard coding of ocaml abi version anywhere
  * debian/control
    - bumped standards version
  * debian/patches/
    - ported 17_build to this upstream release
    - removed 19_install_mlis, no longer needed
    - added 23_meta_version, fix META version number

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 13 Nov 2005 00:21:57 +0000

ulex (0.7-2) unstable; urgency=low

  * debian/rules
    - uses cdbs
  * debian/control
    - added build-dep on cdbs, bumped debhelper deb accordingly

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 25 May 2005 12:45:46 +0200

ulex (0.7-1) unstable; urgency=low

  * New upstream release

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 24 May 2005 17:24:58 +0200

ulex (0.5-3) unstable; urgency=low

  * Rebuilt against ocaml 3.08.3

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 24 Mar 2005 22:40:00 +0100

ulex (0.5-2) unstable; urgency=low

  * rebuilt against ocaml 3.08.2

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 29 Nov 2004 23:00:39 +0100

ulex (0.5-1) unstable; urgency=low

  * New upstream release
  * rebuilt with ocaml 3.08
  * debian/control
    - bumped ocaml deps to 3.08
    - bumped standards-version to 3.6.1.1
    - changed ocaml deps to ocaml-nox

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 26 Jul 2004 16:00:58 +0200

ulex (0.4-2) unstable; urgency=low

  * Ship also ulexing.mli in <stdlib>/ulex

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 15 Jan 2004 20:22:26 +0100

ulex (0.4-1) unstable; urgency=low


=== debian/control ===
Source: ulex
Section: ocaml
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 7.1.0~),
 ocaml-nox (>= 3.11),
 camlp4,
 camlp4-extra,
 ocaml-findlib (>= 1.2.4),
 dh-ocaml (>= 0.9),
 ocamlbuild,
 cdbs
Standards-Version: 3.8.4
Vcs-Git: https://salsa.debian.org/ocaml-team/ulex.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ulex
Homepage: http://www.cduce.org/download.html#side

Package: ocaml-ulex
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml lexer generator with Unicode support
 ulex is a lexer generator for the Objective Caml (OCaml) programming
 language.
 .
 It is implemented as a Camlp4 syntax extension: lexer specifications
 are embedded in regular OCaml code.
 .
 Generated lexers work with a new kind of "lexbuf" that supports
 Unicode; a single lexer can work with arbitrary encodings of the input
 stream.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/ocaml.mk

PKGNAME = ocaml-ulex
OCAML_OCAMLDOC_PACKAGES = $(PKGNAME)
DEB_MAKE_INSTALL_TARGET = install DESTDIR=$(CURDIR)/debian/$(PKGNAME)$(OCAML_STDLIB_DIR)
OCAML_DHOCAML_FLAGS = --runtime-map=ocaml-ulex

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
build/$(PKGNAME)::
	$(MAKE) all.opt
endif

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

http://www.cduce.org/download.html \
  http://www.cduce.org/download/ulex-(.*)\.tar\.gz

## ulex 1.2

=== Makefile ===
ALL=pa_ulex.cma ulexing.cma
OCAMLBUILD=ocamlbuild -byte-plugin

all::
	$(OCAMLBUILD) $(ALL)
all.opt::
	$(OCAMLBUILD) $(ALL) $(ALL:.cma=.cmxa)

MODS=ulexing utf16 utf8

install: all
	cd _build && $(MAKE) -f ../Makefile realinstall

realinstall:
	ocamlfind install ulex ../META $(wildcard $(MODS:=.mli) $(MODS:=.cmi) $(MODS:=.cmx) pa_ulex.cma ulexing.a ulexing.cma ulexing.cmxa)

uninstall:
	ocamlfind remove ulex

clean:
	$(OCAMLBUILD) -clean
	rm -f *~ *.html *.css *.tar.gz

view_test: all
	camlp4o -printer ocaml ./_build/pa_ulex.cma test.ml

run_test:
	ocamlbuild test.byte
	./test.byte

custom_ulexing.byte:
	$(OCAMLBUILD) custom_ulexing.byte

doc:
	ocamldoc -html ulexing.mli

VERSION      := $$(opam query --version)
NAME_VERSION := $$(opam query --name-version)
ARCHIVE      := $$(opam query --archive)

release:
	git tag -a v$(VERSION) -m "Version $(VERSION)."
	git push origin v$(VERSION)
	opam publish prepare $(NAME_VERSION) $(ARCHIVE)
	cp -t $(NAME_VERSION) descr
	grep -Ev '^(name|version):' opam >$(NAME_VERSION)/opam
	opam publish submit $(NAME_VERSION)
	rm -rf $(NAME_VERSION)

=== debian/changelog ===
ulex (1.2-3build3) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 21:18:57 +0200

ulex (1.2-3build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 14:05:37 +0100

ulex (1.2-3build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:29:10 +0200

ulex (1.2-3) unstable; urgency=medium

  * Team upload
  * Fix build with OCaml 5.x

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 Jun 2024 09:23:46 +0200

ulex (1.2-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Bump Standards-Version to 4.6.2

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Update watch file format version to 4.
  * Set upstream metadata fields: Repository-Browse.
  * Update pattern for GitHub archive URLs from /<org>/<repo>/tags
    page/<org>/<repo>/archive/<tag> -> /<org>/<repo>/archive/refs/tags/<tag>.
  * debian/watch: Use GitHub /tags rather than /releases page.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 07:58:51 +0200

ulex (1.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Remove myself from Uploaders
  * Update Homepage and debian/watch
  * Bump debhelper compat level to 13 and stop using cdbs
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Mon, 24 Aug 2020 04:53:07 +0200

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

PKGNAME = ocaml-ulex

%:
	dh $@ --with ocaml

override_dh_auto_build:
	dh_auto_build
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE) all.opt
endif

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/$(PKGNAME)$(OCAML_STDLIB_DIR)

override_dh_ocaml:
	dh_ocaml --runtime-map=ocaml-ulex

=== debian/watch ===
version=4
https://github.com/whitequark/ulex/tags .*/archive/refs/tags/v?([0-9.]+)\.tar\.gz
